.TH "ofm2opl" "1" "September 2000" "Omega" "Omega" 
.PP 
.SH "NAME" 
ofm2opl \- convert Omega and TeX font-metric files to
property-list files
.PP 
.SH "SYNOPSIS" 
.PP 
\fBofm2opl\fP [ \fIOPTION\fP\&.\&.\&. ] \fIOFMNAME\fP[\&.ofm] [
\fIOPLFILE\fP[\&.opl] ]
.PP 
.SH "DESCRIPTION" 
.PP 
\fBofm2opl\fP translates a binary Omega Font Metrics file,
\fIOFMNAME\fP, into a human-readable property-list form\&.  The
program writes to standard output (by default) or to a file specified
as \fIOPLFILE\fP\&.
.PP 
The program also works with TeX TFM files, producing TeX PL files\&.
(\fBofm2opl\fP is based on the WEB source code for \fBtftopl\fP(1)\&.)
.PP 
.SH "OPTIONS" 
.PP 
.IP 
.IP "\fB-charcode-format=\fP\fITYPE\fP" 
output character codes
according to \fITYPE\fP,
which can be either `hex\&'
or `ascii\&'\&.  Default is
`hex\&'\&.  ascii specifes all
ASCII letters and digits;
hex gets you everything
else\&.
.IP 
.IP "\fB-help\fP" 
display a brief summary of syntax and options 
.IP "\fB-verbose\fP" 
display progress reports
.IP "\fB-version\fP" 
output version information and exit
.IP 
.PP 
.SH "FILES" 
.PP 
.IP "\fIOFMNAME\fP" 
an Omega Font Metric file
.IP "\fIOPLFILE\fP" 
an Omega Property List file
.PP 
.SH "BUGS" 
.PP 
None known, but report any found to <omega@ens\&.fr> (mailing list)\&.  You may also want to
check to see if the same bug is present in \fBpltotf\fP(1)\&.
.PP 
.SH "SEE ALSO" 
.PP 
\fBomega\fP(1), \fBopl2ofm\fP(1), \fBpltotf\fP(1),
\fBtftopl\fP(1)\&.
.PP 
\fIDraft Manual for the Omega System\fP (\fIomega-manual\&.dvi\fP)\&.
.PP 
Web page: <http://www\&.gutenberg\&.eu\&.org/omega/>
.PP 
.SH "AUTHOR" 
.PP 
According to the WEB documentation:
.PP 
.RS 
The first \fBTFtoPL\fP program was designed by Leo Guibas in the
summer of 1978\&.  Contributions by Frank Liang, Doug Wyatt, and Lyle
Ramshaw also had a significant effect on the evolution of the present
code\&.
.PP 
Extensions for an enhanced ligature mechanism were added by D\&.E\&. Knuth
in 1989\&.
.PP 
Extensions to handle extended font metric files (``OFM\&'\&') were added
by John Plaice in December 1995 and January 1996, resulting in the new
program \fBOFM2OPL\fP\&.
.RE 
.PP 
The primary authors of Omega are John Plaice
<plaice@cse\&.unsw\&.edu\&.au> and Yannis Haralambous 
<yannis@fluxus-virus\&.com>\&.
.PP 
This manual page was written by C\&.M\&. Connelly
<cmc@debian\&.org>, for
the Debian GNU/Linux system\&.  It may be used by other distributions
without contacting the author\&.  Any mistakes or omissions in the
manual page are my fault; inquiries about or corrections to this
manual page should be directed to me (and not to the primary author)\&.
