.TH "ovf2ovp" "1" "September 2000" "Omega" "Omega" 
.PP 
.SH "NAME" 
ovf2ovp \- convert a virtual font file and its associated
font metric file into property-list format
.PP 
.SH "SYNOPSIS" 
.PP 
\fBovf2ovp\fP [ \fIOPTION\fP\&.\&.\&. ] \fIOVFNAME\fP[\&.ovf] [ [
\fIOFMNAME\fP[\&.ofm] ] [ \fIOVPFILE\fP[\&.ovp] ] ]
.PP 
.SH "DESCRIPTION" 
.PP 
\fBovf2ovp\fP translates a virtual font (OVF) file, \fIOVFNAME\fP,
and its companion font metric (OFM) file, \fIOFMNAME\fP, into a
human-readable property-list format\&.  The program writes to standard
output (by default) or to a file specified as \fIOVPNAME\fP\&.
.PP 
The program also works with TeX VF and TFM files, producing TeX VP
files\&.  (\fBovf2ovp\fP is based on the WEB source code for
\fBvftovp\fP(1)\&.)
.PP 
.SH "OPTIONS" 
.PP 
.IP 
.IP "\fB-charcode-format=\fP\fITYPE\fP" 
output character codes
according to \fITYPE\fP, which can be either `hex\&' or `ascii\&'\&.
Default is `hex\&'\&.  ascii specifes all ASCII letters and digits; hex
gets you everything else\&.
.IP 
.IP "\fB-help\fP" 
display a brief summary of syntax and options 
.IP "\fB-verbose\fP" 
display progress reports
.IP "\fB-version\fP" 
output version information and exit
.IP 
.PP 
.SH "FILES" 
.PP 
.IP "\fIOVPFILE\fP" 
Omega Virtual Property List file
.IP "\fIOFMNAME\fP" 
Omega Font Metric file
.IP "\fIOVFNAME\fP" 
Omega Virtual Font file
.PP 
.SH "BUGS" 
.PP 
None known, but report any found to <omega@ens\&.fr> (mailing list)\&.  You should also
check to see if the bug is also in \fBvftovp\fP(1)\&.
.PP 
.SH "SEE ALSO" 
.PP 
\fBomega\fP(1), \fBofm2opl\fP(1), \fBovp2ovf\fP(1),
\fBpltotf\fP(1), \fBtftopl\fP(1), \fBvftovp\fP(1),
\fBvptovf\fP(1)
.PP 
\fIDraft Manual for the Omega System\fP (\fIomega-manual\&.dvi\fP)\&.
.PP 
Web page: <http://www\&.gutenberg\&.eu\&.org/omega/>
.PP 
.SH "AUTHOR" 
.PP 
According to the WEB documentation:
.PP 
.RS 
\fBVFtoVP\fP is an extended version of the program \fBTFtoPL\fP,
which is part of the standard tex()ware library\&.  The idea of a
virtual font was inspired by the work of David R\&. Fuchs who designed a
similar set of conventions in 1984 while developing a device driver
for ArborText, Inc\&.  He wrote a somewhat similar program called
\fBAMFtoXPL\fP\&.
.RE 
.PP 
The primary authors of Omega are John Plaice
<plaice@cse\&.unsw\&.edu\&.au> and Yannis Haralambous 
<yannis@fluxus-virus\&.com>\&.
.PP 
This manual page was written by C\&.M\&. Connelly
<cmc@debian\&.org>, for
the Debian GNU/Linux system\&.  It may be used by other distributions
without contacting the author\&.  Any mistakes or omissions in the
manual page are my fault; inquiries about or corrections to this
manual page should be directed to me (and not to the primary author)\&.
.PP 
